<template>
  <div :key="$route.path">
    <SfLoader v-if="loading" :loading="loading" class="sw-gs-page-loader"/>

    <SwGsError v-else-if="error && !(notAuthorizedError)" :error="error" :joinAsGuideError="joinAsGuideError"></SwGsError>

    <SwGsLoginPage v-else-if="!isGuideAuthenticated" :isGuide="true"/>
    
    <template v-else-if="showProductPage || showLikeListPage || currentPage">
      <SwPluginSlot name="gs-page-content">
        <ProductPage v-if="showProductPage && currentPageResponse"
                     :page="currentPageResponse"
                     :key="currentPageResponse.product.id"
                     class="sw-gs-cms-page sw-gs-dynamic-product-page"/>
        <SwGsLikeListPage v-else-if="showLikeListPage && likeList" :like-list="likeList"/>
        <CmsPage v-show="!showProductPage && !showLikeListPage"
                 class="sw-gs-cms-page"
                 :class="{'sw-gs-cms-product-page': currentPageResponse && currentPageResponse.product}"
                 :content="currentPage"
                 :id="currentPageKey"
                 :key="currentPageKey"/>
      </SwPluginSlot>
    </template>
  </div>
</template>

<script lang="ts">
  import { computed, onMounted, ref, watch } from '@vue/composition-api';
  import { provide } from "vue-demi";
  import { usePresentation } from '../logic/composables/usePresentation';
  import { useAppointment } from '../logic/composables/useAppointment';
  import { useInstantListing } from '../logic/composables/useInstantListing';
  import { useAdminApiInstance } from '../logic/composables/useAdminApiInstance';
  import { useLikeList } from "../logic/composables/useLikeList";
  import { useState } from "../logic/composables/useState";
  import { useGsRoute } from "../logic/composables/useGsRoute";
  import { useMercure } from "../logic/composables/useMercure";
  import { useMercureObserver } from "../logic/composables/useMercureObserver";
  import { useGsCart } from "../logic/composables/useGsCart";
  import { SfLoader } from '@storefront-ui/vue';
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
  import CmsPage from '@/cms/CmsPage.vue';

  const ProductPage = () => import("@/components/views/frontend.detail.page.vue");
  const SwGsLikeListPage = () => import("../components/views/SwGsLikeListPage.vue");
  const SwGsLoginPage = () => import("../components/views/SwGsLoginPage.vue");
  const SwGsError = () => import("../components/SwGsError.vue");

  export default {
    name: 'PresentationGuidePage',
    components: {
      SwGsLoginPage,
      SfLoader,
      CmsPage,
      ProductPage,
      SwGsLikeListPage,
      SwGsError,
      SwPluginSlot,
    },
    setup() {
      const { joinAsGuide, joinedAppointment, appointmentId, joinError, joinErrorAsGuide, getVideoOrAudioAvailableStatus } = useAppointment();
      const { isGuideAuthenticated, keepAliveToken: keepAliveAdminApiToken } = useAdminApiInstance();
      const { loadPresentation, currentPage, currentPageResponse, showProductPage, loadPresentationError, slideLoading} = usePresentation();
      const { initLikeListForGuide, likeList, showLikeListPage } = useLikeList();
      const { initCartForGuide,} = useGsCart();
      const { initState } = useState();
      const { appointmentId: routeAppointmentId, slide: routeSlideIndex, slideGroup: routeSlideGroupIndex, il } = useGsRoute();
      const { openInstantListing } = useInstantListing();
      const { connect } = useMercure();
      const { subscribeToMercureEvents } = useMercureObserver();

      const loading = ref(true);

      provide("cms-page", currentPageResponse);

      provide("gs-product-page-type", computed(() => {
        if (showProductPage.value && currentPageResponse.value) {
          return 'dynamic-page';
        } else if (currentPage.value) {
          return 'cms-page';
        }
        return null;
      }));

      async function setupPage() {
        await keepAliveAdminApiToken().catch(() => {});
        await getVideoOrAudioAvailableStatus(routeAppointmentId.value);

        if (!isGuideAuthenticated.value) {
          loading.value = false;
          return;
        }

        if (!joinedAppointment.value) {
          appointmentId.value = routeAppointmentId.value;
          await joinAsGuide();
        }

        if (joinError.value) {
          loading.value = false;
          return;
        }

        // connect to mercure
        connect();
        subscribeToMercureEvents();

        // state needs to be loaded first
        await initState();

        // load presentation and init like list
        loading.value = true;
        await loadPresentation(routeSlideIndex.value, routeSlideGroupIndex.value);
        loading.value = false;
        initLikeListForGuide();
        initCartForGuide();
      }

      onMounted(async () => {
        await setupPage();
        const validInstantListing = ['create', 'edit'].includes(il.value);
        if (validInstantListing) openInstantListing(il.value);
      });

      watch(isGuideAuthenticated, async (newValue) => {
        if (newValue !== true) return;
        loading.value = true;
        await setupPage();
      });

      // trigger page setup again if no more errors are present but also no state
      watch(joinError, async () => {
        loading.value = true;
        await setupPage();
      });
      
      return {
        currentPage,
        currentPageKey: computed(() => currentPage?.value?.sections[0]?._uniqueIdentifier),
        currentPageResponse,
        showProductPage,
        likeList,
        showLikeListPage,
        loading: computed(() => loading.value || slideLoading.value),
        isGuideAuthenticated,
        error: computed(() => joinError.value || loadPresentationError.value),
        joinError: computed(() => joinError.value),
        notAuthorizedError: computed(() => joinError.value?.statusCode === 401),
        forbiddenError: computed(() => joinError.value?.statusCode === 403),
        joinAsGuideError: computed(() => joinErrorAsGuide.value),
      };
    },
  };
</script>
